POJ 3126 Prime Path



 链接:http://poj.org/problem?id=3126

Description

The ministers of the cabinet were quite upset by the message from the Chief of Security stating that they would all have to change the four-digit room numbers on their offices.
— It is a matter of security to change such things every now and then, to keep the enemy in the dark.
— But look, I have chosen my number 1033 for good reasons. I am the Prime minister, you know!
— I know, so therefore your new number 8179 is also a prime. You will just have to paste four new digits over the four old ones on your office door.
— No, it’s not that simple. Suppose that I change the first digit to an 8, then the number will read 8033 which is not a prime!
— I see, being the prime minister you cannot stand having a non-prime number on your door even for a few seconds.
— Correct! So I must invent a scheme for going from 1033 to 8179 by a path of prime numbers where only one digit is changed from one prime to the next prime.

Now, the minister of finance, who had been eavesdropping, intervened.
— No unnecessary expenditure, please! I happen to know that the price of a digit is one pound.
— Hmm, in that case I need a computer program to minimize the cost. You don't know some very cheap software gurus, do you?
— In fact, I do. You see, there is this programming contest going on... Help the prime minister to find the cheapest prime path between any two given four-digit primes! The first digit must be nonzero, of course. Here is a solution in the case above.
1033
1733
3733
3739
3779
8779
8179
The cost of this solution is 6 pounds. Note that the digit 1 which got pasted over in step 2 can not be reused in the last step – a new 1 must be purchased.

Input

One line with a positive number: the number of test cases (at most 100). Then for each test case, one line with two numbers separated by a blank. Both numbers are four-digit primes (without leading zeros).

Output

One line for each case, either with a number stating the minimal cost or containing the word Impossible.

Sample Input

3
1033 8179
1373 8017
1033 1033

Sample Output

6
7
0
 
 
解题思路:典型的bfs,将4位的素数,分解出各位的数字,每次改变一个数字(从0-9);判断是否是素数可以打出素数表(注意素数表别打错了,我一开始表打错了,一直wa,悲剧啊。。。)。还有一些地方需要剪枝,这个数是素数,而且是4位数,这些都是限定条件。
 
 
#include <iostream>
#include <queue>
#include <cstring>
#include <cmath>
using namespace std;

int prime[10010], m, n, vis[10010], num[10010];
queue<int> q;

int is_prime(int n)
{
	for(int i = 2; i <= sqrt(n); i++)
	{
		if(0 == n % i) return 0;
	}
	return 1;
}

int bfs()
{
	int a, b, c, d;
	q.push(m);
	vis[m] = 1;
	num[m] = 0;

	while(!q.empty())
	{
		int tmp = q.front(), t;
		q.pop();
		a = tmp / 1000;
		b = tmp / 100 % 10;
		c = tmp / 10 % 10;
		d = tmp % 10;

		for(int i = 0; i < 4; i++)
		{
			switch(i)
			{
			case 0: t = b*100 + c*10 + d;      break;
			case 1: t = a*1000 + c*10 + d;     break;
			case 2: t = a*1000 + b*100 + d;    break;
			case 3: t = a*1000 + b*100 + c*10; break;
			}

			int w = 1, j;
			for(j = 0; j < i; j++) w *= 10;

			for(j = 0; j < 10; j++)
			{
				int v = t + j * 1000 / w;
				if(v > 999 && v < 10000 && !vis[v] && prime[v])
				{
					vis[v] = 1;
					q.push(v);
					num[v] = num[tmp] + 1;
					if(v == n) return num[n];
				}
			}
		}
	}

	return -1;
}

int main()
{
	int t, i;
	memset(prime, 0, sizeof(prime));
	for(i = 1000; i < 10000; i++)
	{
		if(is_prime(i)) prime[i] = 1;
	}

	cin >> t;
	while(t--)
	{
		memset(vis, 0, sizeof(vis));
		memset(num, 0, sizeof(num));
		cin >> m >> n;

		if(m == n && prime[m])
		{
			cout << 0 << endl;
			continue;
		}

		int tmp = bfs();

		if(tmp + 1) cout << tmp << endl;
		else cout << "Impossible" << endl;

		while(!q.empty()) q.pop();
	}

	return 0;
}

评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值